# PROG2900

## Endpoints
```
\
\update_map?lake=*
\get_relation?lake=*
\add_new_lake?lake=*
\add_test_data?lake=*
```

## Server
To run the server...


### Adding lakes to the system
To add a new lake to the system, go to https://overpass-turbo.eu/.
Once you have navigated to Overpass API, enter
the Overpass query below in the left field, but swap 'lakeName' out
with the name of the lake you want to add. Once the query has been adjusted,
press the 'Run' button.

```
[out:json];
(
  way["natural"="water"]["name"="lakeName"];
  relation["natural"="water"]["name"="lakeName"];
);
(._;>;);
out body;
```

![img.png](images/overpass-query.png)
![img.png](images/geojson-export.png)

If a text box saying "This query returned quite a lot of data (approx. x MB). Your browser may have a hard time trying to render this. Do you really want to continue?
" appears, press 'continue anyway'. Double check that you have
the correct lake, then press 'Export'. In the 'Export' menu, download the shape data as
GeoJson. Once downloaded, name the file the *lakeName.json, and move the file into
IceMap/server/lake_relations. Once you have added the file, run map division...

![img.png](images/geojson-file.png)

The result will be two new files named lakeName_centers.txt and lakeName_div.json. The original
lakeName.geojson file should also remain in the system. Additionally, the file named all_lake_names.json
should be updated to contain the newly added lake name.

![img.png](images/resulting-files.png)

### Dependencies

## Database
This project requires SQLite3. Download the precompiled binary for your operating system. 
Precompiled binaries can be found on https://www.sqlite.org/download.html. Extract the downloaded
binary in a folder and note its path. Add the path to your system environment variables. Now you can 
manage the SQLite database.

## Application
In order to run the application on a physical device, the port randomization of Dart must
first be bypassed. To do this, run the adb command ```reverse tcp:8443 tcp:8443 ```. This must be
repeated every time the IDE in which the application is running is restarted. A simpler alternative
is to add the command to the run configuration as an external tool.

### Dependencies

## Known bugs

## Developers
This software was developed by Joakim Aleksandersen, Sara Savanovic Djordjevic, 
and Hoa Ben The Nguyen.